// 
// File:          sort_SortTest_Impl.cc
// Symbol:        sort.SortTest-v0.1
// Symbol Type:   class
// Babel Version: 0.10.8
// Description:   Server-side implementation for sort.SortTest
// 
// WARNING: Automatically generated; only changes within splicers preserved
// 
// babel-version = 0.10.8
// 
#include "sort_SortTest_Impl.hh"

#line 14 "../../../../babel/regression/sort/libCxx/sort_SortTest_Impl.cc"
// DO-NOT-DELETE splicer.begin(sort.SortTest._includes)
#include <stdlib.h>
#include <stdio.h>
#include "sort_CompInt.hh"
#include "sort_IntegerContainer.hh"
#include "synch_RegOut.hh"

static std::string
intToString(int i)
{
  char buf[64];
  sprintf(buf, "%d", i);
  return buf;
}

static const int32_t s_testSizes[] = {
  0,
  1,
  2,
  3,
  4,
  7,
  10,
  51,
  64,
  -1
};

static bool
notSorted(sort::Container  &cont,
          sort::Comparator &comp)
{
  const int32_t length = cont.getLength();
  for(int32_t i = 1 ; i < length ; ++i ){
    if (cont.compare(i-1, i, comp) > 0) return true;
  }
  return false;
}

static void
sortAndReport(sort::SortingAlgorithm &alg,
	      sort::Container        &cont,
	      sort::Comparator       &comp, 
	      bool                   &result)
{
  sort::Counter swpCnt;
  sort::Counter cmpCnt;
  alg.reset();
  alg.sort(cont, comp);
  swpCnt = alg.getSwapCounter();
  cmpCnt = alg.getCompareCounter();
  std::string buf = std::string("compares (") + 
    intToString(cmpCnt.getCount()) + ") swaps (" +
    intToString(swpCnt.getCount()) + ")";
  synch::RegOut::getInstance().writeComment(buf);
  if (notSorted(cont, comp)) {
    synch::RegOut::getInstance().writeComment("sort failed!!");
    result = false;
  }
}
// DO-NOT-DELETE splicer.end(sort.SortTest._includes)
#line 76 "sort_SortTest_Impl.cc"

// user-defined constructor.
void sort::SortTest_impl::_ctor() {
#line 78 "../../../../babel/regression/sort/libCxx/sort_SortTest_Impl.cc"
  // DO-NOT-DELETE splicer.begin(sort.SortTest._ctor)
  // add construction details here
  // DO-NOT-DELETE splicer.end(sort.SortTest._ctor)
#line 84 "sort_SortTest_Impl.cc"
}

// user-defined destructor.
void sort::SortTest_impl::_dtor() {
#line 85 "../../../../babel/regression/sort/libCxx/sort_SortTest_Impl.cc"
  // DO-NOT-DELETE splicer.begin(sort.SortTest._dtor)
  // add destruction details here
  // DO-NOT-DELETE splicer.end(sort.SortTest._dtor)
#line 93 "sort_SortTest_Impl.cc"
}

// static class initializer.
void sort::SortTest_impl::_load() {
#line 92 "../../../../babel/regression/sort/libCxx/sort_SortTest_Impl.cc"
  // DO-NOT-DELETE splicer.begin(sort.SortTest._load)
  // guaranteed to be called at most once before any other method in this class
  // DO-NOT-DELETE splicer.end(sort.SortTest._load)
#line 102 "sort_SortTest_Impl.cc"
}

// user-defined static methods:
/**
 * Perform the array stress test.
 * 
 * Return true if all the algorithms work okay.
 */
bool
sort::SortTest_impl::stressTest (
  /* in */ ::sidl::array< ::sort::SortingAlgorithm> algs ) 
throw () 
{
#line 108 "../../../../babel/regression/sort/libCxx/sort_SortTest_Impl.cc"
  // DO-NOT-DELETE splicer.begin(sort.SortTest.stressTest)
  bool result = false;
  if (algs._not_nil()) {
    const int32_t lower = algs.lower(0);
    const int32_t upper = algs.upper(0);
    int32_t i,j;
    result = true;
    for(i = lower; i <= upper; ++i) {
      sort::SortingAlgorithm alg = algs.get(i);
      if (alg._not_nil()) {
        sort::IntegerContainer data = sort::IntegerContainer::_create();
        sort::Container cont = data;
	sort::CompInt intcomp = sort::CompInt::_create();
        sort::Comparator comp = intcomp;
        std::string name = alg.getName();
        j = 0;
	std::string buf = "****ALGORITHM IS " + name + "****";
	synch::RegOut::getInstance().writeComment(buf);
        while (s_testSizes[j] >= 0) {
	  synch::RegOut tracker = synch::RegOut::getInstance();
	  std::string buf2 = "DATA SIZE " + intToString(s_testSizes[j]);
	  intcomp.setSortIncreasing(true);
	  tracker.writeComment(buf2);
	  data.setLength(s_testSizes[j]);
	  sortAndReport(alg, cont, comp, result);
	  tracker.writeComment("pre-sorted list");
	  sortAndReport(alg, cont, comp, result);
	  tracker.writeComment("reverse sorted list");
          intcomp.setSortIncreasing(false);
	  sortAndReport(alg, cont, comp, result);
          ++j;
        }
      }
      else{
        result = false;
      }
    }
  }
  return result;
  // DO-NOT-DELETE splicer.end(sort.SortTest.stressTest)
#line 157 "sort_SortTest_Impl.cc"
}


// user-defined non-static methods: (none)

#line 153 "../../../../babel/regression/sort/libCxx/sort_SortTest_Impl.cc"
// DO-NOT-DELETE splicer.begin(sort.SortTest._misc)
// Put miscellaneous code here
// DO-NOT-DELETE splicer.end(sort.SortTest._misc)
#line 167 "sort_SortTest_Impl.cc"

